`timescale 1ns / 1ps
// Anthony Curnes - this code was provided
module Nbit_reg(in, out, clk, we, gwe, rst);
   parameter n = 1;
   parameter r = 0;
 
   output [n-1:0] out;
   input [n-1:0]  in;   
   input          clk;
   input          we;
   input          gwe;
   input          rst;      

   reg [n-1:0] state;

   assign #(1) out = state;

   always @(posedge clk) 
     begin 
       if (rst) 
         state = r;
       else if (we & gwe) 
         state = in; 
     end
endmodule
